#! /usr/bin/python
#################################################
#  GtkRun version 0.1b. Copyright 2002.
#  Erica Andrews (PhrozenSmoke@yahoo.com)
#  All rights reserved.
#
#  GtkRun is a Gtk-based "Run" dialog, similar to the
#  the "Run..." dialog found on Windows systems. GtkRun
#  does not require Gnome, but does require PyGtk and
#  Python  (PyGtk 0.6.9+ recommended with Python 2.2+).
#
#  This software is open source, released under the W3C
#  license.  It is free for non-commercial and non-profit 
#  use, modification, and distribution, provided these 
#  credits are left in-tact and unmodified.
#################################################
import os, copy,GTK,gtk
from gtk import *
from _gtk import *
from threading import Thread

class runwindow:
  def __init__ (self) :
    runwindow = GtkWindow (GTK.WINDOW_TOPLEVEL)
    self._root = runwindow
    tips=GtkTooltips()
    self.rcommands=[]
    self.cmd_file=".gtkruncmd"
    self.last_file="/usr/X11R6/bin/gedit"
    runwindow.realize()
    runwindow.set_title ("Gtk Run")
    runwindow.set_position (GTK.WIN_POS_NONE)
    h=101
    runwindow.set_usize(415,h)
    try:
      runwindow.set_uposition(9,(gtk.screen_height()-h)-56)
    except:
      pass
    tips.set_tip(runwindow,"Gtk Run: Run A Command")
    self.runwindow = runwindow
    vbox1 = GtkVBox (0, 0)
    vbox1.set_border_width ( 5)
    self.vbox1 = vbox1
    hbox1 = GtkHBox (1, 0)
    self.hbox1 = hbox1
    cmdlab = GtkLabel ("Command to run:")
    cmdlab.set_justify (GTK.JUSTIFY_LEFT)
    cmdlab.set_alignment ( 0.12, 0.5)
    self.cmdlab = cmdlab
    hbox1.pack_start ( cmdlab, 1, 1, 0)
    spacer1 = GtkLabel ("  ")
    self.spacer1 = spacer1
    hbox1.pack_start ( spacer1, 1, 1, 0)
    vbox1.pack_start ( hbox1, 1, 1, 0)
    hbox2 = GtkHBox (0, 0)
    self.hbox2 = hbox2
    runcombo = GtkCombo ()
    self.runcombo = runcombo
    runentry = runcombo.entry
    self.runentry = runentry
    hbox2.pack_start ( runcombo, 1, 1, 9)
    browsebutt = GtkButton("Browse...")
    tips.set_tip(browsebutt,"Open the file browser")
    browsebutt.connect("clicked",self.showFileSel)
    self.browsebutt = browsebutt
    hbox2.pack_start ( browsebutt, 0, 0, 0)
    vbox1.pack_start (hbox2, 1, 1, 2)
    hbox3 = GtkHBox (1, 0)
    hbox3.set_border_width ( 4)
    self.hbox3 = hbox3
    runbutt = GtkButton("Run")
    tips.set_tip(runbutt,"Run the selected command")
    self.runbutt = runbutt
    self.runbutt.connect("clicked",self.runCommand)
    hbox3.pack_start ( runbutt, 1, 1, 0)
    spacer2 = GtkLabel ("  ")
    self.spacer2 = spacer2
    hbox3.pack_start ( spacer2, 0, 0, 0)
    cancelbutt = GtkButton("Close")
    tips.set_tip(cancelbutt,"Close and exit")
    cancelbutt.connect("clicked",self.quitit)
    self.cancelbutt = cancelbutt
    hbox3.pack_start ( cancelbutt, 1, 1, 0)
    vbox1.pack_start ( hbox3, 1, 1, 5)
    runwindow.add(vbox1)
    runwindow.connect("destroy",self.quitit)
    self.loadCommands()
    runwindow.show_all()

  def showFileSel(self,*args):
    self.fs = GtkFileSelection()
    self.fs.set_title("Select An Executable...")
    self.fs.connect('destroy', self.doFsHide)
    self.fs.connect('delete_event', self.doFsHide)
    self.fslabel = self.fs.ok_button.children()[0]
    self.fslabel.set_text('Select')
    self.fs.ok_button.connect('clicked', self.grabFile)
    self.fslabel = self.fs.cancel_button.children()[0]
    self.fslabel.set_text('Cancel')
    self.fs.cancel_button.connect('clicked', self.doFsHide)
    self.fs.set_filename(self.last_file)
    self.fs.show_all()
    return TRUE

  def doFsHide(self,*args):
    self.fs.hide()
    self.fs.destroy()
    self.fs=None
    return TRUE

  def grabFile(self,*args):   
    rcmd=self.fs.get_filename()
    if rcmd:
      if not str(rcmd).endswith("/"):
        self.runentry.set_text(str(rcmd))
        self.last_file=str(rcmd)
        self.doFsHide()

  def runCommand(self,*args):
    r=self.runentry.get_text().strip()
    if r:
      self.addCommand(r)
      self.saveCommands()
      self.updateCombo()
      os.popen(r+" &")

  def addCommand(self,rcmd):
    if rcmd:
      try:
        self.rcommands.remove(rcmd)
      except:
        pass
      self.rcommands.insert(0,rcmd)

  def updateCombo(self):
    l=copy.copy(self.rcommands)
    self.runcombo.set_popdown_strings(l)
    self.runcombo.show_all()

  def saveCommands(self):
      if not self.cmd_file: return
      try:
        f=open(self.cmd_file,"w")
        f.write("# Gtk Run file: DO NOT EDIT!\n")
        l=copy.copy(self.rcommands)
        if len(l) > 10:  l=l[0:10]
        l.reverse()
        for i in l:
          f.write(str(i)+"\n")
        f.flush()
        f.close()
      except:
        pass

  def loadCommands(self):
    try:
      hdir=str(os.environ["HOME"]).strip()
      if not hdir.endswith("/"): hdir=hdir+"/"
      self.cmd_file=hdir+".gtkruncmd"
    except:
      self.cmd_file=".gtkruncmd"
    try:
      f=open(self.cmd_file)
      scmd=f.read()
      f.close()
      clist=scmd.split("\n")
      for i in clist:
        cstr=i.strip()
        if cstr:
          if not cstr.startswith("#"): self.addCommand(cstr)
      self.updateCombo()
    except:
      pass

  def quitit(self,*args):
    self.saveCommands()
    gtk_main_quit ()

def run (*args) :
    gtk_init ()
    runwindow ()
    gtk_main ()

if __name__ == "__main__" :
    t=Thread(None,run)
    t.start()